diff --git a/ui/app/controllers/CControllerAuthenticationUpdate.php b/ui/app/controllers/CControllerAuthenticationUpdate.php
index 5ae1d6e3c0a..187bf3db693 100644
--- a/ui/app/controllers/CControllerAuthenticationUpdate.php
+++ b/ui/app/controllers/CControllerAuthenticationUpdate.php
@@ -35,42 +35,38 @@ class CControllerAuthenticationUpdate extends CController {
 
 	protected function checkInput() {
 		$fields = [
-			'form_refresh' =>				'string',
-			'ldap_test_user' =>				'string',
-			'ldap_test_password' =>			'string',
-			'ldap_test' =>					'in 1',
-			'db_authentication_type' =>		'int32',
-			'change_bind_password' =>		'in 0,1',
-			'authentication_type' =>		'in '.ZBX_AUTH_INTERNAL.','.ZBX_AUTH_LDAP,
-			'http_case_sensitive' =>		'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
-			'ldap_case_sensitive' =>		'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
-			'ldap_configured' =>			'in '.ZBX_AUTH_LDAP_DISABLED.','.ZBX_AUTH_LDAP_ENABLED,
-			'ldap_host' =>					'db config.ldap_host',
-			'ldap_port' =>					'int32',
-			'ldap_base_dn' =>				'db config.ldap_base_dn',
-			'ldap_bind_dn' =>				'db config.ldap_bind_dn',
-			'ldap_search_attribute' =>		'db config.ldap_search_attribute',
-			'ldap_bind_password' =>			'db config.ldap_bind_password',
-			'http_auth_enabled' =>			'in '.ZBX_AUTH_HTTP_DISABLED.','.ZBX_AUTH_HTTP_ENABLED,
-			'http_login_form' =>			'in '.ZBX_AUTH_FORM_ZABBIX.','.ZBX_AUTH_FORM_HTTP,
-			'http_strip_domains' =>			'db config.http_strip_domains',
-			'saml_auth_enabled' =>			'in '.ZBX_AUTH_SAML_DISABLED.','.ZBX_AUTH_SAML_ENABLED,
-			'saml_idp_entityid' =>			'db config.saml_idp_entityid',
-			'saml_sso_url' =>				'db config.saml_sso_url',
-			'saml_slo_url' =>				'db config.saml_slo_url',
-			'saml_username_attribute' =>	'db config.saml_username_attribute',
-			'saml_sp_entityid' =>			'db config.saml_sp_entityid',
-			'saml_nameid_format' =>			'db config.saml_nameid_format',
-			'saml_sign_messages' =>			'in 0,1',
-			'saml_sign_assertions' =>		'in 0,1',
-			'saml_sign_authn_requests' =>	'in 0,1',
-			'saml_sign_logout_requests' =>	'in 0,1',
-			'saml_sign_logout_responses' =>	'in 0,1',
-			'saml_encrypt_nameid' =>		'in 0,1',
-			'saml_encrypt_assertions' =>	'in 0,1',
-			'saml_case_sensitive' =>		'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
-			'passwd_min_length' =>			'int32',
-			'passwd_check_rules' =>			'array'
+			'form_refresh' =>					'string',
+			'ldap_test_user' =>					'string',
+			'ldap_test_password' =>				'string',
+			'ldap_test' =>						'in 1',
+			'change_bind_password' =>			'in 0,1',
+			'authentication_type' =>			'in '.ZBX_AUTH_INTERNAL.','.ZBX_AUTH_LDAP,
+			'http_case_sensitive' =>			'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
+			'ldap_configured' =>				'in '.ZBX_AUTH_LDAP_DISABLED.','.ZBX_AUTH_LDAP_ENABLED,
+			'ldap_servers' =>					'array',
+			'ldap_default_row_index' =>			'int32',
+			'ldap_case_sensitive' =>			'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
+			'ldap_removed_userdirectoryids' =>	'array',
+			'http_auth_enabled' =>				'in '.ZBX_AUTH_HTTP_DISABLED.','.ZBX_AUTH_HTTP_ENABLED,
+			'http_login_form' =>				'in '.ZBX_AUTH_FORM_ZABBIX.','.ZBX_AUTH_FORM_HTTP,
+			'http_strip_domains' =>				'db config.http_strip_domains',
+			'saml_auth_enabled' =>				'in '.ZBX_AUTH_SAML_DISABLED.','.ZBX_AUTH_SAML_ENABLED,
+			'saml_idp_entityid' =>				'db config.saml_idp_entityid',
+			'saml_sso_url' =>					'db config.saml_sso_url',
+			'saml_slo_url' =>					'db config.saml_slo_url',
+			'saml_username_attribute' =>		'db config.saml_username_attribute',
+			'saml_sp_entityid' =>				'db config.saml_sp_entityid',
+			'saml_nameid_format' =>				'db config.saml_nameid_format',
+			'saml_sign_messages' =>				'in 0,1',
+			'saml_sign_assertions' =>			'in 0,1',
+			'saml_sign_authn_requests' =>		'in 0,1',
+			'saml_sign_logout_requests' =>		'in 0,1',
+			'saml_sign_logout_responses' =>		'in 0,1',
+			'saml_encrypt_nameid' =>			'in 0,1',
+			'saml_encrypt_assertions' =>		'in 0,1',
+			'saml_case_sensitive' =>			'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
+			'passwd_min_length' =>				'int32',
+			'passwd_check_rules' =>				'array'
 		];
 
 		$ret = $this->validateInput($fields);
@@ -113,78 +109,33 @@ class CControllerAuthenticationUpdate extends CController {
 	 *
 	 * @return bool
 	 */
-	private function validateLdap() {
-		$is_valid = true;
-		$ldap_status = (new CFrontendSetup())->checkPhpLdapModule();
-		$ldap_fields = ['ldap_host', 'ldap_port', 'ldap_base_dn', 'ldap_search_attribute', 'ldap_configured'];
-		$ldap_auth_original = [
-			'ldap_host' => CAuthenticationHelper::get(CAuthenticationHelper::LDAP_HOST),
-			'ldap_port' => CAuthenticationHelper::get(CAuthenticationHelper::LDAP_PORT),
-			'ldap_base_dn' => CAuthenticationHelper::get(CAuthenticationHelper::LDAP_BASE_DN),
-			'ldap_search_attribute' => CAuthenticationHelper::get(CAuthenticationHelper::LDAP_SEARCH_ATTRIBUTE),
-			'ldap_configured' => CAuthenticationHelper::get(CAuthenticationHelper::LDAP_CONFIGURED),
-			'ldap_bind_dn' => CAuthenticationHelper::get(CAuthenticationHelper::LDAP_BIND_DN),
-			'ldap_bind_password' => CAuthenticationHelper::get(CAuthenticationHelper::LDAP_BIND_PASSWORD)
-		];
-		$ldap_auth = $ldap_auth_original;
-		$this->getInputs($ldap_auth, array_merge($ldap_fields, ['ldap_bind_dn', 'ldap_bind_password']));
-		$ldap_auth_changed = array_diff_assoc($ldap_auth, $ldap_auth_original);
+	private function validateLdap(): bool {
+		$ldap_enabled = $this->getInput('ldap_configured', ZBX_AUTH_LDAP_DISABLED) == ZBX_AUTH_LDAP_ENABLED;
+		$ldap_servers = $this->getInput('ldap_servers', []);
 
-		if (!$ldap_auth_changed && !$this->hasInput('ldap_test')) {
-			return $is_valid;
-		}
+		if ($ldap_enabled) {
+			$ldap_status = (new CFrontendSetup())->checkPhpLdapModule();
 
-		if ($this->getInput('ldap_bind_password', '') !== '') {
-			$ldap_fields[] = 'ldap_bind_dn';
-		}
-
-		foreach ($ldap_fields as $field) {
-			if (trim($ldap_auth[$field]) === '') {
-				CMessageHelper::setErrorTitle(_s('Incorrect value for field "%1$s": %2$s.', $field, _('cannot be empty')));
-				$is_valid = false;
-				break;
+			if ($ldap_status['result'] != CFrontendSetup::CHECK_OK) {
+				CMessageHelper::setErrorTitle($ldap_status['error']);
+				return false;
 			}
-		}
-
-		if ($is_valid
-				&& ($ldap_auth['ldap_port'] < ZBX_MIN_PORT_NUMBER
-					|| $ldap_auth['ldap_port'] > ZBX_MAX_PORT_NUMBER)) {
-			CMessageHelper::setErrorTitle(_s(
-				'Incorrect value "%1$s" for "%2$s" field: must be between %3$s and %4$s.', $this->getInput('ldap_port'),
-				'ldap_port', ZBX_MIN_PORT_NUMBER, ZBX_MAX_PORT_NUMBER
-			));
-			$is_valid = false;
-		}
 
-		if ($ldap_status['result'] != CFrontendSetup::CHECK_OK) {
-			CMessageHelper::setErrorTitle($ldap_status['error']);
-			$is_valid = false;
+			if (!$ldap_servers) {
+				CMessageHelper::setErrorTitle(_('At least one LDAP server must exist.'));
+				return false;
+			}
 		}
-		elseif ($is_valid) {
-			$ldap_validator = new CLdapAuthValidator([
-				'conf' => [
-					'host' => $ldap_auth['ldap_host'],
-					'port' => $ldap_auth['ldap_port'],
-					'base_dn' => $ldap_auth['ldap_base_dn'],
-					'bind_dn' => $ldap_auth['ldap_bind_dn'],
-					'bind_password' => $ldap_auth['ldap_bind_password'],
-					'search_attribute' => $ldap_auth['ldap_search_attribute']
-				],
-				'detailed_errors' => true
-			]);
-
-			$login = $ldap_validator->validate([
-				'username' => $this->getInput('ldap_test_user', CWebUser::$data['username']),
-				'password' => $this->getInput('ldap_test_password', '')
-			]);
 
-			if (!$login) {
-				CMessageHelper::setErrorTitle($ldap_validator->getError());
-				$is_valid = false;
-			}
+		if ($ldap_servers
+				&& (!$this->hasInput('ldap_default_row_index')
+					|| !array_key_exists($this->getInput('ldap_default_row_index'), $ldap_servers)
+				)) {
+			CMessageHelper::setErrorTitle(_('Default LDAP server must be specified.'));
+			return false;
 		}
 
-		return $is_valid;
+		return true;
 	}
 
 	/**
@@ -251,9 +202,11 @@ class CControllerAuthenticationUpdate extends CController {
 	}
 
 	protected function doAction() {
-		$auth_valid = ($this->getInput('ldap_configured', '') == ZBX_AUTH_LDAP_ENABLED)
-			? $this->validateLdap()
-			: $this->validateDefaultAuth();
+		$auth_valid = $this->validateDefaultAuth();
+
+		if ($auth_valid && !$this->validateLdap()) {
+			$auth_valid = false;
+		}
 
 		if ($auth_valid && $this->getInput('saml_auth_enabled', ZBX_AUTH_SAML_DISABLED) == ZBX_AUTH_SAML_ENABLED) {
 			if (!$this->validateSamlAuth()) {
@@ -261,16 +214,14 @@ class CControllerAuthenticationUpdate extends CController {
 			}
 		}
 
-		if (!$auth_valid) {
-			$this->response->setFormData($this->getInputAll());
-			$this->setResponse($this->response);
-
-			return;
+		if ($auth_valid) {
+			[$auth_valid, $ldap_userdirectoryid] = $this->processLdapServers(
+				$this->getInput('ldap_servers', []),
+				$this->getInput('ldap_default_row_index', 0)
+			);
 		}
 
-		// Only ZBX_AUTH_LDAP have 'Test' option.
-		if ($this->hasInput('ldap_test')) {
-			CMessageHelper::setSuccessTitle(_('LDAP login successful'));
+		if (!$auth_valid) {
 			$this->response->setFormData($this->getInputAll());
 			$this->setResponse($this->response);
 
@@ -283,14 +234,9 @@ class CControllerAuthenticationUpdate extends CController {
 			CAuthenticationHelper::HTTP_LOGIN_FORM,
 			CAuthenticationHelper::HTTP_STRIP_DOMAINS,
 			CAuthenticationHelper::HTTP_CASE_SENSITIVE,
-			CAuthenticationHelper::LDAP_CASE_SENSITIVE,
 			CAuthenticationHelper::LDAP_CONFIGURED,
-			CAuthenticationHelper::LDAP_HOST,
-			CAuthenticationHelper::LDAP_PORT,
-			CAuthenticationHelper::LDAP_BASE_DN,
-			CAuthenticationHelper::LDAP_BIND_DN,
-			CAuthenticationHelper::LDAP_SEARCH_ATTRIBUTE,
-			CAuthenticationHelper::LDAP_BIND_PASSWORD,
+			CAuthenticationHelper::LDAP_USERDIRECTORYID,
+			CAuthenticationHelper::LDAP_CASE_SENSITIVE,
 			CAuthenticationHelper::SAML_AUTH_ENABLED,
 			CAuthenticationHelper::SAML_IDP_ENTITYID,
 			CAuthenticationHelper::SAML_SSO_URL,
@@ -317,6 +263,8 @@ class CControllerAuthenticationUpdate extends CController {
 		$fields = [
 			'authentication_type' => ZBX_AUTH_INTERNAL,
 			'ldap_configured' => ZBX_AUTH_LDAP_DISABLED,
+			'ldap_userdirectoryid' => $ldap_userdirectoryid,
+			'ldap_case_sensitive' => ZBX_AUTH_CASE_INSENSITIVE,
 			'http_auth_enabled' => ZBX_AUTH_HTTP_DISABLED,
 			'saml_auth_enabled' => ZBX_AUTH_SAML_DISABLED,
 			'passwd_min_length' => DB::getDefault('config', 'passwd_min_length'),
@@ -331,24 +279,6 @@ class CControllerAuthenticationUpdate extends CController {
 			];
 		}
 
-		if ($this->getInput('ldap_configured', ZBX_AUTH_LDAP_DISABLED) == ZBX_AUTH_LDAP_ENABLED) {
-			$fields += [
-				'ldap_host' => '',
-				'ldap_port' => '',
-				'ldap_base_dn' => '',
-				'ldap_bind_dn' => '',
-				'ldap_search_attribute' => '',
-				'ldap_case_sensitive' => 0
-			];
-
-			if ($this->hasInput('ldap_bind_password')) {
-				$fields['ldap_bind_password'] = '';
-			}
-			else {
-				unset($auth[CAuthenticationHelper::LDAP_BIND_PASSWORD]);
-			}
-		}
-
 		if ($this->getInput('saml_auth_enabled', ZBX_AUTH_SAML_DISABLED) == ZBX_AUTH_SAML_ENABLED) {
 			$fields += [
 				'saml_idp_entityid' => '',
@@ -379,33 +309,92 @@ class CControllerAuthenticationUpdate extends CController {
 		}
 
 		$data = array_diff_assoc($data, $auth);
-
-		if (array_key_exists('ldap_bind_dn', $data) && trim($data['ldap_bind_dn']) === '') {
-			$data['ldap_bind_password'] = '';
-		}
+		$result = true;
 
 		if ($data) {
 			$result = API::Authentication()->update($data);
 
-			if ($result) {
-				if (array_key_exists('authentication_type', $data)) {
-					$this->invalidateSessions();
-				}
-
-				CMessageHelper::setSuccessTitle(_('Authentication settings updated'));
+			if ($result && array_key_exists('authentication_type', $data)) {
+				$this->invalidateSessions();
 			}
-			else {
-				$this->response->setFormData($this->getInputAll());
-				CMessageHelper::setErrorTitle(_('Cannot update authentication'));
+		}
+
+		if ($result) {
+			$del_userdirectoryids = $this->getInput('ldap_removed_userdirectoryids', []);
+
+			if ($del_userdirectoryids) {
+				$result = API::UserDirectory()->delete($del_userdirectoryids);
 			}
 		}
-		else {
+
+		if ($result) {
 			CMessageHelper::setSuccessTitle(_('Authentication settings updated'));
 		}
+		else {
+			$this->response->setFormData($this->getInputAll());
+			CMessageHelper::setErrorTitle(_('Cannot update authentication'));
+		}
 
 		$this->setResponse($this->response);
 	}
 
+	/**
+	 * Updates existing LDAP servers, creates new ones, removes deleted ones.
+	 *
+	 * @param array $ldap_servers
+	 * @param int $default_row_index
+	 *
+	 * @return array
+	 */
+	private function processLdapServers(array $ldap_servers, int $default_row_index): array {
+		$ins_ldap_servers = [];
+		$upd_ldap_servers = [];
+
+		$ldap_userdirectoryid = 0;
+		$default_ldap_mapping_index = null;
+
+		foreach ($ldap_servers as $row_index => $ldap_server) {
+			if (array_key_exists('userdirectoryid', $ldap_server)) {
+				$upd_ldap_servers[] = $ldap_server;
+
+				if ($default_row_index == $row_index) {
+					$ldap_userdirectoryid = $ldap_server['userdirectoryid'];
+				}
+			}
+			else {
+				$ins_ldap_servers[] = $ldap_server;
+
+				if ($default_row_index == $row_index) {
+					$default_ldap_mapping_index = count($ins_ldap_servers) - 1;
+				}
+			}
+		}
+
+		if ($upd_ldap_servers && !API::UserDirectory()->update($upd_ldap_servers)) {
+			return [false, $ldap_userdirectoryid];
+		}
+
+		if ($ins_ldap_servers) {
+			$inserted_ids = API::UserDirectory()->create($ins_ldap_servers);
+
+			if (!$inserted_ids) {
+				return [false, $ldap_userdirectoryid];
+			}
+
+			if ($default_ldap_mapping_index !== null) {
+				$ldap_userdirectoryid = $inserted_ids['userdirectoryids'][$default_ldap_mapping_index];
+			}
+		}
+
+		if ($ldap_servers && $ldap_userdirectoryid === 0) {
+			CMessageHelper::setErrorTitle(_('Failed to select default LDAP server.'));
+
+			return [false, $ldap_userdirectoryid];
+		}
+
+		return [true, $ldap_userdirectoryid];
+	}
+
 	/**
 	 * Mark all active GROUP_GUI_ACCESS_INTERNAL sessions, except current user sessions, as ZBX_SESSION_PASSIVE.
 	 *
diff --git a/ui/app/controllers/CControllerPopupLdapCheck.php b/ui/app/controllers/CControllerPopupLdapCheck.php
new file mode 100644
index 00000000000..4f7a4bb7eb1
--- /dev/null
+++ b/ui/app/controllers/CControllerPopupLdapCheck.php
@@ -0,0 +1,97 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+class CControllerPopupLdapCheck extends CController {
+
+	protected function init(): void {
+		$this->disableSIDValidation();
+
+		$this->setPostContentType(self::POST_CONTENT_TYPE_JSON);
+	}
+
+	protected function checkInput(): bool {
+		$fields = [
+			'row_index' =>			'required|int32',
+			'userdirectoryid' =>	'db userdirectory.userdirectoryid',
+			'name' =>				'required|db userdirectory.name|not_empty',
+			'host' =>				'required|db userdirectory.host|not_empty',
+			'port' =>				'required|db userdirectory.port|ge '.ZBX_MIN_PORT_NUMBER.'|le '.ZBX_MAX_PORT_NUMBER,
+			'base_dn' =>			'required|db userdirectory.base_dn|not_empty',
+			'bind_dn' =>			'db userdirectory.bind_dn',
+			'bind_password' =>		'db userdirectory.bind_password',
+			'search_attribute' =>	'required|db userdirectory.search_attribute|not_empty',
+			'start_tls' =>			'in '.ZBX_AUTH_START_TLS_OFF.','.ZBX_AUTH_START_TLS_ON,
+			'search_filter' =>		'db userdirectory.search_filter',
+			'description' =>		'db userdirectory.description'
+		];
+
+		$ret = $this->validateInput($fields);
+
+		if (!$ret) {
+			$this->setResponse(
+				new CControllerResponseData(['main_block' => json_encode([
+					'error' => [
+						'title' => _('Invalid LDAP configuration'),
+						'messages' => array_column(get_and_clear_messages(), 'message')
+					]
+				])])
+			);
+		}
+
+		return $ret;
+	}
+
+	protected function checkPermissions(): bool {
+		return $this->checkAccess(CRoleHelper::UI_ADMINISTRATION_AUTHENTICATION);
+	}
+
+	protected function doAction(): void {
+		$data = [
+			'body' => [
+				'row_index' => $this->getInput('row_index'),
+				'name' => $this->getInput('name'),
+				'host' => $this->getInput('host'),
+				'port' => $this->getInput('port'),
+				'base_dn' => $this->getInput('base_dn'),
+				'search_attribute' => $this->getInput('search_attribute'),
+				'start_tls' => $this->getInput('start_tls', ZBX_AUTH_START_TLS_OFF),
+				'bind_dn' => $this->getInput('bind_dn', ''),
+				'description' => $this->getInput('description', ''),
+				'search_filter' => $this->getInput('search_filter', '')
+			]
+		];
+
+		if ($this->hasInput('userdirectoryid')) {
+			$data['body']['userdirectoryid'] = $this->getInput('userdirectoryid');
+		}
+
+		if ($this->hasInput('bind_password')) {
+			$data['body']['bind_password'] = $this->getInput('bind_password');
+		}
+
+		if ($this->getDebugMode() == GROUP_DEBUG_MODE_ENABLED) {
+			CProfiler::getInstance()->stop();
+			$data['debug'] = CProfiler::getInstance()->make()->toString();
+		}
+
+		$this->setResponse(new CControllerResponseData(['main_block' => json_encode($data)]));
+	}
+}
diff --git a/ui/app/controllers/CControllerPopupLdapEdit.php b/ui/app/controllers/CControllerPopupLdapEdit.php
new file mode 100644
index 00000000000..f565e131655
--- /dev/null
+++ b/ui/app/controllers/CControllerPopupLdapEdit.php
@@ -0,0 +1,95 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+class CControllerPopupLdapEdit extends CController {
+
+	protected function checkInput(): bool {
+		$fields = [
+			'row_index' =>			'required|int32',
+			'userdirectoryid' =>	'db userdirectory.userdirectoryid',
+			'name' =>				'db userdirectory.name',
+			'host' =>				'db userdirectory.host',
+			'port' =>				'db userdirectory.port|ge '.ZBX_MIN_PORT_NUMBER.'|le '.ZBX_MAX_PORT_NUMBER,
+			'base_dn' =>			'db userdirectory.base_dn',
+			'bind_dn' =>			'db userdirectory.bind_dn',
+			'bind_password' =>		'db userdirectory.bind_password',
+			'search_attribute' =>	'db userdirectory.search_attribute',
+			'start_tls' =>			'in '.ZBX_AUTH_START_TLS_OFF.','.ZBX_AUTH_START_TLS_ON,
+			'search_filter' =>		'db userdirectory.search_filter',
+			'case_sensitive' =>		'in '.ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE,
+			'description' =>		'db userdirectory.description',
+			'add_ldap_server' =>	'in 0,1'
+		];
+
+		$ret = $this->validateInput($fields);
+
+		if (!$ret) {
+			$this->setResponse(
+				(new CControllerResponseData([
+					'main_block' => json_encode(['errors' => getMessages()->toString()])
+				]))->disableView()
+			);
+		}
+
+		return $ret;
+	}
+
+	/**
+	 * @throws APIException
+	 */
+	protected function checkPermissions(): bool {
+		return $this->checkAccess(CRoleHelper::UI_ADMINISTRATION_AUTHENTICATION);
+	}
+
+	/**
+	 * @throws Exception
+	 */
+	protected function doAction(): void {
+		$data = [
+			'row_index' => $this->getInput('row_index', 0),
+			'name' => $this->getInput('name', ''),
+			'host' => $this->getInput('host', ''),
+			'port' => $this->getInput('port', '389'),
+			'base_dn' => $this->getInput('base_dn', ''),
+			'search_attribute' => $this->getInput('search_attribute', ''),
+			'start_tls' => $this->getInput('start_tls', ZBX_AUTH_START_TLS_OFF),
+			'bind_dn' => $this->getInput('bind_dn', ''),
+			'description' => $this->getInput('description', ''),
+			'search_filter' => $this->getInput('search_filter', ''),
+			'add_ldap_server' => $this->getInput('add_ldap_server', 1),
+			'user' => [
+				'debug_mode' => $this->getDebugMode()
+			]
+		];
+
+		if ($this->hasInput('userdirectoryid')) {
+			$data['userdirectoryid'] = $this->getInput('userdirectoryid');
+		}
+
+		if ($this->hasInput('bind_password')) {
+			$data['bind_password'] = $this->getInput('bind_password');
+		}
+
+		$data['advanced_configuration'] = $data['start_tls'] != ZBX_AUTH_START_TLS_OFF || $data['search_filter'] !== '';
+
+		$this->setResponse(new CControllerResponseData($data));
+	}
+}
diff --git a/ui/app/controllers/CControllerPopupLdapTestEdit.php b/ui/app/controllers/CControllerPopupLdapTestEdit.php
new file mode 100644
index 00000000000..e067fcf7bad
--- /dev/null
+++ b/ui/app/controllers/CControllerPopupLdapTestEdit.php
@@ -0,0 +1,69 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+class CControllerPopupLdapTestEdit extends CController {
+
+	protected function checkInput(): bool {
+		$fields = [
+			'userdirectoryid' =>	'db userdirectory.userdirectoryid',
+			'host' =>				'required|db userdirectory.host|not_empty',
+			'port' =>				'required|db userdirectory.port|ge '.ZBX_MIN_PORT_NUMBER.'|le '.ZBX_MAX_PORT_NUMBER,
+			'base_dn' =>			'required|db userdirectory.base_dn|not_empty',
+			'bind_dn' =>			'db userdirectory.bind_dn',
+			'bind_password' =>		'db userdirectory.bind_password',
+			'search_attribute' =>	'required|db userdirectory.search_attribute|not_empty',
+			'start_tls' =>			'in '.ZBX_AUTH_START_TLS_OFF.','.ZBX_AUTH_START_TLS_ON,
+			'search_filter' =>		'db userdirectory.search_filter'
+		];
+
+		$ret = $this->validateInput($fields);
+
+		if (!$ret) {
+			$this->setResponse(
+				(new CControllerResponseData([
+					'main_block' => json_encode(['errors' => getMessages()->toString()])
+				]))->disableView()
+			);
+		}
+
+		return $ret;
+	}
+
+	protected function checkPermissions(): bool {
+		return $this->checkAccess(CRoleHelper::UI_ADMINISTRATION_AUTHENTICATION);
+	}
+
+	protected function doAction(): void {
+		$data = [
+			'ldap_config' => [],
+			'user' => [
+				'debug_mode' => $this->getDebugMode()
+			],
+			'test_username' => CWebUser::$data['username']
+		];
+
+		$this->getInputs($data['ldap_config'], ['userdirectoryid', 'host', 'port', 'base_dn', 'bind_dn',
+			'bind_password', 'search_attribute', 'start_tls', 'search_filter','test_username', 'test_password'
+		]);
+
+		$this->setResponse(new CControllerResponseData($data));
+	}
+}
diff --git a/ui/app/controllers/CControllerPopupLdapTestSend.php b/ui/app/controllers/CControllerPopupLdapTestSend.php
new file mode 100644
index 00000000000..b982e5e6302
--- /dev/null
+++ b/ui/app/controllers/CControllerPopupLdapTestSend.php
@@ -0,0 +1,91 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+class CControllerPopupLdapTestSend extends CController {
+
+	protected function init(): void {
+		$this->setPostContentType(self::POST_CONTENT_TYPE_JSON);
+	}
+
+	protected function checkInput(): bool {
+		$fields = [
+			'userdirectoryid' =>	'db userdirectory.userdirectoryid',
+			'host' =>				'required|db userdirectory.host|not_empty',
+			'port' =>				'required|db userdirectory.port|ge '.ZBX_MIN_PORT_NUMBER.'|le '.ZBX_MAX_PORT_NUMBER,
+			'base_dn' =>			'required|db userdirectory.base_dn|not_empty',
+			'bind_dn' =>			'db userdirectory.bind_dn',
+			'bind_password' =>		'db userdirectory.bind_password',
+			'search_attribute' =>	'required|db userdirectory.search_attribute|not_empty',
+			'start_tls' =>			'in '.ZBX_AUTH_START_TLS_OFF.','.ZBX_AUTH_START_TLS_ON,
+			'search_filter' =>		'db userdirectory.search_filter',
+			'test_username' =>		'required|string|not_empty',
+			'test_password' =>		'required|string|not_empty'
+		];
+
+		$ret = $this->validateInput($fields);
+
+		if (!$ret) {
+			$this->setResponse(
+				new CControllerResponseData(['main_block' => json_encode([
+					'error' => [
+						'title' => _('Invalid LDAP configuration'),
+						'messages' => array_column(get_and_clear_messages(), 'message')
+					]
+				])])
+			);
+		}
+
+		return $ret;
+	}
+
+	protected function checkPermissions(): bool {
+		return $this->checkAccess(CRoleHelper::UI_ADMINISTRATION_AUTHENTICATION);
+	}
+
+	protected function doAction(): void {
+		$ldap_test_object = [];
+		$this->getInputs($ldap_test_object, ['userdirectoryid', 'host', 'port', 'base_dn', 'bind_dn', 'bind_password',
+			'search_attribute', 'start_tls', 'search_filter','test_username', 'test_password'
+		]);
+
+		$result = API::UserDirectory()->test($ldap_test_object);
+
+		$output = [];
+
+		if ($result) {
+			$success = ['title' => _('Login successful')];
+
+			if ($messages = get_and_clear_messages()) {
+				$success['messages'] = array_column($messages, 'message');
+			}
+
+			$output['success'] = $success;
+		}
+		else {
+			$output['error'] = [
+				'title' => _('Login failed'),
+				'messages' => array_column(get_and_clear_messages(), 'message')
+			];
+		}
+
+		$this->setResponse(new CControllerResponseData(['main_block' => json_encode($output)]));
+	}
+}
diff --git a/ui/app/controllers/CControllerUsergroupCreate.php b/ui/app/controllers/CControllerUsergroupCreate.php
index cd83ddfb916..6c3c7d975a9 100644
--- a/ui/app/controllers/CControllerUsergroupCreate.php
+++ b/ui/app/controllers/CControllerUsergroupCreate.php
@@ -23,19 +23,20 @@ class CControllerUsergroupCreate extends CController {
 
 	protected function checkInput() {
 		$fields = [
-			'name'            => 'required|not_empty|db usrgrp.name',
-			'userids'         => 'array_db users.userid',
-			'gui_access'      => 'db usrgrp.gui_access|in '.implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED]),
-			'users_status'    => 'db usrgrp.users_status|in '.GROUP_STATUS_ENABLED.','.GROUP_STATUS_DISABLED,
-			'debug_mode'      => 'db usrgrp.debug_mode|in '.GROUP_DEBUG_MODE_ENABLED.','.GROUP_DEBUG_MODE_DISABLED,
+			'name' =>				'required|not_empty|db usrgrp.name',
+			'userids' =>			'array_db users.userid',
+			'gui_access' =>			'db usrgrp.gui_access|in '.implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED]),
+			'users_status' =>		'db usrgrp.users_status|in '.GROUP_STATUS_ENABLED.','.GROUP_STATUS_DISABLED,
+			'debug_mode' =>			'db usrgrp.debug_mode|in '.GROUP_DEBUG_MODE_ENABLED.','.GROUP_DEBUG_MODE_DISABLED,
+			'userdirectoryid' =>	'db usrgrp.userdirectoryid',
 
-			'group_rights'    => 'array',
-			'tag_filters'     => 'array',
+			'group_rights' =>		'array',
+			'tag_filters' =>		'array',
 
-			'new_group_right' => 'array',
-			'new_tag_filter'  => 'array',
+			'new_group_right' =>	'array',
+			'new_tag_filter' =>		'array',
 
-			'form_refresh'    => 'int32'
+			'form_refresh' =>		'int32'
 		];
 
 		$ret = $this->validateInput($fields);
@@ -71,7 +72,9 @@ class CControllerUsergroupCreate extends CController {
 			'rights' => []
 		];
 
-		$this->getInputs($user_group, ['name', 'users_status', 'gui_access', 'debug_mode', 'tag_filters']);
+		$this->getInputs($user_group, ['name', 'users_status', 'gui_access', 'debug_mode', 'tag_filters',
+			'userdirectoryid'
+		]);
 
 		$group_rights = applyHostGroupRights($this->getInput('group_rights', []));
 
diff --git a/ui/app/controllers/CControllerUsergroupEdit.php b/ui/app/controllers/CControllerUsergroupEdit.php
index 4e1ee157f8f..ea04abf456f 100644
--- a/ui/app/controllers/CControllerUsergroupEdit.php
+++ b/ui/app/controllers/CControllerUsergroupEdit.php
@@ -64,7 +64,7 @@ class CControllerUsergroupEdit extends CController {
 
 		if ($this->hasInput('usrgrpid')) {
 			$user_groups = API::UserGroup()->get([
-				'output' => ['name', 'gui_access', 'users_status', 'debug_mode'],
+				'output' => ['name', 'gui_access', 'users_status', 'debug_mode', 'userdirectoryid'],
 				'selectTagFilters' => ['groupid', 'tag', 'value'],
 				'usrgrpids' => $this->getInput('usrgrpid'),
 				'editable' => true
@@ -87,6 +87,7 @@ class CControllerUsergroupEdit extends CController {
 			'usrgrpid' => 0,
 			'name' => $db_defaults['name'],
 			'gui_access' => $db_defaults['gui_access'],
+			'userdirectoryid' => 0,
 			'users_status' => $db_defaults['users_status'],
 			'debug_mode' => $db_defaults['debug_mode'],
 			'form_refresh' => 0
@@ -99,6 +100,7 @@ class CControllerUsergroupEdit extends CController {
 			$data['gui_access'] = $this->user_group['gui_access'];
 			$data['users_status'] = $this->user_group['users_status'];
 			$data['debug_mode'] = $this->user_group['debug_mode'];
+			$data['userdirectoryid'] = $this->user_group['userdirectoryid'];
 		}
 
 		// overwrite with input variables
@@ -126,6 +128,14 @@ class CControllerUsergroupEdit extends CController {
 
 		$data['can_update_group'] = (!$this->hasInput('usrgrpid') || granted2update_group($this->getInput('usrgrpid')));
 
+		if ($data['can_update_group']) {
+			$userdirectories = API::UserDirectory()->get([
+				'output' => ['userdirectoryid', 'name']
+			]);
+			CArrayHelper::sort($userdirectories, ['name']);
+			$data['userdirectories'] = array_column($userdirectories, 'name', 'userdirectoryid');
+		}
+
 		$response = new CControllerResponseData($data);
 		$response->setTitle(_('Configuration of user groups'));
 		$this->setResponse($response);
